gStar4D
=======

The gStar4D algorithm uses the neighbourhood information in the digital Voronoi
diagram as an approximation of the Delaunay triangulation. It uses this to
perform massively parallel creation of stars of each input point lifted to R4
and employs an unique star splaying approach to splay these 4D stars in
parallel and make them consistent.

Our CUDA implementation of gStar4D achieves a speedup of up to 5 times over the
3D Delaunay triangulator of CGAL.

Setup
=====

This project has been created using Visual Studio 2008 and CUDA 4.0 on
Windows 7 64-bit OS.
It has been tested on a workstation with Intel i7 2600K CPU and
NVIDIA GTX 580 GPU.

Reference
=========

This CUDA implementation is based on the gStar4D algorithm described
in Chapter 6 of:

Nanjappa, Ashwin (2012). "Delaunay triangulation in R3 on the GPU". 
Ph.D. Thesis. National University of Singapore.

Citation
========

To cite gStar4D in your publication, please use this BibTeX entry:

    @phdthesis{ashwin2012,
        author = {Nanjappa, Ashwin},
        school = {National University of Singapore},
        title = {Delaunay triangulation in R3 on the {GPU}},
        year = {2012}
    }

License
=======

Author: Ashwin Nanjappa

Project: gStar4D

Copyright (c) 2013, School of Computing, National University of Singapore. 
All rights reserved.

Project homepage: http://www.comp.nus.edu.sg/~tants/gdel3d.html

If you use gStar4D and you like it or have comments on its usefulness etc., we 
would love to hear from you at <tants@comp.nus.edu.sg>. You may share with us
your experience and any possibilities that we may improve the work/code.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

Redistributions of source code must retain the above copyright notice, this list of
conditions and the following disclaimer. Redistributions in binary form must reproduce
the above copyright notice, this list of conditions and the following disclaimer
in the documentation and/or other materials provided with the distribution. 

Neither the name of the National University of University nor the names of its contributors
may be used to endorse or promote products derived from this software without specific
prior written permission from the National University of Singapore. 

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO THE IMPLIED WARRANTIES 
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
TO, PROCUREMENT OF SUBSTITUTE  GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
DAMAGE.
